﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Xml.Linq;

namespace Fireball.OpenXML
{
    public static class Extensions
    {
        //public static string ToHexColor(this Color c)
        //{
        //    string f = String.Format("{0:X2}", Convert.ToInt32(c.R));
        //    f+= String.Format("{0:X2}", Convert.ToInt32(c.G));
        //    f += String.Format("{0:X2}", Convert.ToInt32(c.B));
        //    return f;
        //}

        public static string GetOfficeValAttribute(this XElement e)
        {
            var attr = e.Attribute(NS.WM + "val");

            if (attr != null)
                return attr.Value;
            return null;
        }

        public static T GetEnum<T>(this string s)
        {
            return (T)Enum.Parse(typeof(T), s, true);
        }

        public static string ToOnOff(this bool b)
        {
            return (b ? "1" : "0");
        }

        public static bool ToBoolean(this string s)
        {
            if (s.ToLower() == "on")
                return true;
            else if (s.ToLower() == "off")
                return false;
            else if (s == "1")
            {
                return true;
            }
            else
                return false;
        }

        public static string ToOffice(this Enum e)
        {
            string s = Enum.GetName(e.GetType(), e);
            string tmp = s;
            if (s.Length > 1)
            {
                tmp = s.Substring(0, 1).ToLower() +
                    s.Substring(1);
            }
            return tmp;
        }
    }
}
