﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace Fireball.OpenXML.Word
{
    public enum BreakType
    {
        Line,
        Column,
        Page
    }

    /// <summary>
    /// This run content specify the current break 
    /// type for the container paragraph
    /// </summary>
    public sealed class Break : RunContent
    {
        public BreakType BreakType
        {
            get;
            set;
        }

        private string GetBreakType(BreakType type)
        {
            if (type == BreakType.Column)
                return "column";
            else if (type == BreakType.Line)
                return "textWrapping";
            else
                return "page";
        }

        public override System.Xml.Linq.XContainer ToXml()
        {
            var brElement = new XElement(NS.WM + "br",
                new XAttribute(NS.WM + "type", this.GetBreakType(this.BreakType)));

            return brElement;
        }
    }
}
