﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace Fireball.OpenXML.Word
{
    /// <summary>
    /// This is the base class for any Inline Item
    /// to be inserted mostly on a paragraph.
    /// </summary>
    public abstract class Inline : OpenXMLEntity
    {
        private Paragraph _OwnerParagraph = null;

        public Paragraph OwnerParagraph
        {
            get
            {
                return _OwnerParagraph;
            }
        }

        internal void SetOwnerParagraph(Paragraph owner)
        {
            _OwnerParagraph = owner;
        }

        private HorizontalAlignment _HorizontalAlignment;
        private HorizontalAlignment HorizontalAlignment
        {
            get
            {
                return _HorizontalAlignment;
            }
            set
            {
                _HorizontalAlignment = value;
            }
        }

        private FontStyle _FontStyle = FontStyles.Normal;

        public FontStyle FontStyle
        {
            get
            {
                return _FontStyle;
            }
            set
            {
                _FontStyle = value;
            }
        }


        private FontWeight _FontWeight;

        public FontWeight FontWeight
        {
            get
            {
                return _FontWeight;
            }
            set
            {
                _FontWeight = value;
            }
        }
    }
}
