﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace Fireball.OpenXML.Word
{
    /// <summary>
    /// This class store the revision information about
    /// the owner section
    /// </summary>
    public sealed class SectionRevisionInformation : OpenXMLEntity
    {
        //author
        public string Author
        {
            get;
            set;
        }

        //date
        public DateTime Date
        {
            get;
            set;
        }

        public decimal Id
        {
            get;
            set;
        }

        public SectionProperties PreviousProperties
        {
            get;
            set;
        }

        public override System.Xml.Linq.XContainer ToXml()
        {
            XElement xSectChange = new XElement(NS.WM + "sectPrChange");
            xSectChange.Add(new XAttribute(NS.WM + "author", this.Author));
            xSectChange.Add(new XAttribute(NS.WM + "date", this.Date));
            xSectChange.Add(new XAttribute(NS.WM + "id", this.Id));

            if (this.PreviousProperties != null)
                xSectChange.Add(this.PreviousProperties.ToXml());

            return xSectChange;
        }
    }
}
