﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace Fireball.OpenXML.Word
{
    public sealed class StyleDocDefaults : IOpenXMLEntity
    {
        public ParagraphProperties ParagraphProperties
        {
            get;
            set;
        }

        public StyleRunProperties RunProperties
        {
            get;
            set;
        }


        #region IOpenXMLEntity Members

        public string Name
        {
            get;
            set;
        }

        public System.Xml.Linq.XContainer ToXml()
        {
            XElement xDefaults = new XElement(NS.WM + "docDefaults");

            XElement rprDefault = new XElement(NS.WM + "rPrDefault");
            XElement pPrDefault = new XElement(NS.WM + "pPrDefault");

            if (this.RunProperties != null)
            {
                xDefaults.Add(rprDefault);

                rprDefault.Add(this.RunProperties.ToXml());
            }

            if (this.ParagraphProperties != null)
            {
                xDefaults.Add(pPrDefault);

                pPrDefault.Add(this.ParagraphProperties.ToXml());
            }

            //xDefaults.Add(pPrDefault);

            return xDefaults;
        }

        #endregion
    }
}
