﻿#region MIT Licenze
//The MIT License

//Copyright (c) 2008 Sebastian Faltoni, dotnetfireball.org

//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Media;
using System.Xml.Linq;
using Fireball.Extensions;

namespace Fireball.OpenXML.Word
{
    public class TableCellShading : OpenXMLEntity
    {
        [DefaultValue(ShadingPatterns.nil)]
        public ShadingPatterns Shading
        {
            get;
            set;
        }

        public Color? Color
        {
            get;
            set;
        }

        public Color? Fill
        {
            get;
            set;
        }

        [DefaultValue(ThemeColor.None)]
        public ThemeColor ThemeFill
        {
            get;
            set;
        }

        public override System.Xml.Linq.XContainer ToXml()
        {
            XElement xRoot = new XElement(NS.WM + "shd");

            xRoot.Add(new XAttribute(NS.WM + "val", this.Shading.ToOffice()));
            
            if (this.Color != null)
            {
                xRoot.Add(new XAttribute(NS.WM + "color", this.Color.Value.ToHexFormat()));
            }
            else
            {
                xRoot.Add(new XAttribute(NS.WM + "color", "auto"));
            }
            if (this.Fill != null)
            {
                xRoot.Add(new XAttribute(NS.WM + "fill", this.Fill.Value.ToHexFormat()));
            }
            if (this.ThemeFill != ThemeColor.None)
            {
                xRoot.Add(new XAttribute(NS.WM + "themeFill", this.ThemeFill.ToOffice()));
            }
            return xRoot;
        }
    }
}
